# coding: utf-8


"""
IGNORE:
    Nutanix Clustermgmt Versioned APIs

    Manage Hosts, Clusters and other Infrastructure.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_clustermgmt_py_client.Ntnx.clustermgmt.v4.config.GpuConfig import GpuConfig  # noqa: F401,E501
from ntnx_clustermgmt_py_client.Ntnx.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_clustermgmt_py_client.Ntnx.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class HostGpuEntity(ExternalizableAbstractModel):
    """HostGpuEntity - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'node_uuid': 'str',
        'node_id': 'str',
        'cluster_uuid': 'str',
        'cluster_name': 'str',
        'number_of_vgpus_allocated': 'int',
        'config': 'clustermgmt.v4.config.GpuConfig',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'node_uuid': 'nodeUuid',
        'node_id': 'nodeId',
        'cluster_uuid': 'clusterUuid',
        'cluster_name': 'clusterName',
        'number_of_vgpus_allocated': 'numberOfVgpusAllocated',
        'config': 'config',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, node_uuid=None, node_id=None, cluster_uuid=None, cluster_name=None, number_of_vgpus_allocated=None, config=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        """HostGpuEntity - a model defined in Swagger
            \nHost GPU details
        """
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__node_uuid = None
        self.__node_id = None
        self.__cluster_uuid = None
        self.__cluster_name = None
        self.__number_of_vgpus_allocated = None
        self.__config = None
        self.discriminator = None
        if node_uuid is not None:
            self.__node_uuid = node_uuid
        if node_id is not None:
            self.__node_id = node_id
        if cluster_uuid is not None:
            self.__cluster_uuid = cluster_uuid
        if cluster_name is not None:
            self.__cluster_name = cluster_name
        if number_of_vgpus_allocated is not None:
            self.__number_of_vgpus_allocated = number_of_vgpus_allocated
        if config is not None:
            self.__config = config

    def _initialize_object_type(self):
        return 'clustermgmt.v4.config.HostGpuEntity'

    def _initialize_fq_object_type(self):
        return 'clustermgmt.v4.r0.a1.config.HostGpuEntity'


    @property
    def node_uuid(self):
        """`{ str }`
            \nUUID of a node
        """ # noqa: E501
        return self.__node_uuid

    @node_uuid.setter
    def node_uuid(self, node_uuid):
        if node_uuid is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', node_uuid):  # noqa: E501
            raise ValueError(r"Invalid value for `node_uuid`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__node_uuid = node_uuid

    @property
    def node_id(self):
        """`{ str }`
            \nController VM Id
        """ # noqa: E501
        return self.__node_id

    @node_id.setter
    def node_id(self, node_id):

        self.__node_id = node_id

    @property
    def cluster_uuid(self):
        """`{ str }`
            \nCluster UUID
        """ # noqa: E501
        return self.__cluster_uuid

    @cluster_uuid.setter
    def cluster_uuid(self, cluster_uuid):
        if cluster_uuid is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', cluster_uuid):  # noqa: E501
            raise ValueError(r"Invalid value for `cluster_uuid`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__cluster_uuid = cluster_uuid

    @property
    def cluster_name(self):
        """`{ str }`
            \nCluster name
        """ # noqa: E501
        return self.__cluster_name

    @cluster_name.setter
    def cluster_name(self, cluster_name):

        self.__cluster_name = cluster_name

    @property
    def number_of_vgpus_allocated(self):
        """`{ int }`
            \nNumber of vGPUs allocated
        """ # noqa: E501
        return self.__number_of_vgpus_allocated

    @number_of_vgpus_allocated.setter
    def number_of_vgpus_allocated(self, number_of_vgpus_allocated):

        self.__number_of_vgpus_allocated = number_of_vgpus_allocated

    @property
    def config(self):
        """`{ clustermgmt.v4.config.GpuConfig }`
            
        """ # noqa: E501
        return self.__config

    @config.setter
    def config(self, config):

        self.__config = config

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(HostGpuEntity, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HostGpuEntity):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

